/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPODEPREC                                               */
/* Tabela : TIPODEPREC                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 15/01/2009 - Frederico Gonalves Moreira da Costa                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE
TRIGGER DTULTATU_TIPODEPREC
BEFORE INSERT OR UPDATE OR DELETE
ON TIPODEPREC FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF(NVL(:OLD.CDEMPRESA     ,0) <> NVL(:NEW.CDEMPRESA     ,0)) OR
        (NVL(:OLD.CDTIPODEPREC  ,0) <> NVL(:NEW.CDTIPODEPREC  ,0)) OR
        (NVL(:OLD.NMTIPODEPREC  ,0) <> NVL(:NEW.NMTIPODEPREC  ,0)) OR
        (NVL(:OLD.NMABREVTIPODEP,0) <> NVL(:NEW.NMABREVTIPODEP,0)) OR
        (NVL(:OLD.NRCOETIPODEP  ,0) <> NVL(:NEW.NRCOETIPODEP  ,0)) THEN
         :NEW.DTULTATU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE,CDFILICACHE,DSKEYCACHE,DTULTATUCACH)
      VALUES ('TIPODEPREC','','CDEMPRESA='||:OLD.CDEMPRESA||';CDTIPODEPREC='||:OLD.CDTIPODEPREC||';',SYSDATE);
   END IF;
END;
/
ALTER TABLE TIPODEPREC MODIFY DTULTATU DEFAULT SYSDATE
/
UPDATE TIPODEPREC SET DTULTATU = SYSDATE WHERE DTULTATU IS NULL
/
-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TIPODEPREC','5.05.119'); END;
/

